/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so.winwebdocentes.sqlserverDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Calendar;
import java.util.Objects;
import org.json.JSONArray;
import org.json.JSONObject;
import so.winwebdocentes.DAO.AsistenciaDAO;
import so.winwebdocentes.utilities.ResponseHelper;

/**
 *
 * @author Felipe Escala
 */
public class AsistenciaSqlServerDAO implements AsistenciaDAO {

	@Override
	public JSONObject listarRazonSocial(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql = " SELECT count(*)  "
				+ "FROM INFORMATION_SCHEMA.COLUMNS "
				+ "WHERE TABLE_NAME = 'locales'  "
				+ "AND TABLE_SCHEMA = 'dbo' "
				+ "AND COLUMN_NAME = 'codlocal_pla' ";
			pst = con.prepareStatement(sql);
			rSet = pst.executeQuery();
			if (rSet.next()) {
				rs = rSet.getInt(1);
			}
			if (rs == 1) {
				sql = " SELECT lp.id_razon, ap.des_asoc, ap.nom_asoc	 "
					+ " FROM locales AS ls "
					+ " INNER JOIN BDPersonal.dbo.Local_ AS lp ON ls.codlocal_pla = lp.CodLocal "
					+ " INNER JOIN BDPersonal.dbo.asociacion AS ap ON ap.id_asoc = lp.id_razon "
					+ " GROUP BY lp.id_razon, ap.des_asoc, ap.nom_asoc ";
				pst = con.prepareStatement(sql);
				rSet = pst.executeQuery();
				while (rSet.next()) {
					JSONObject obj = new JSONObject();
					obj.put("idRazon", rSet.getInt(1));
					obj.put("nomRazon", rSet.getString(2));
					obj.put("nomComRazon", rSet.getString(3));
					lista.put(obj);
				}
				response.setStatus(lista.length() > 0);
			} else {
				JSONObject obj = new JSONObject();
				obj.put("idRazon", 88);
				obj.put("nomRazon", "ACESO");
				obj.put("nomComRazon", "ASOCIACION CIVIL EDUCATIVA SACO OLIVEROS");
				lista.put(obj);
				response.setStatus(true);
			}
			response.setResults(lista);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarAsistencias(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn = new JSONObject();
		JSONArray listaAsistencias = new JSONArray();
		JSONArray listaDescuentos = new JSONArray();
		int conta = 1;
		int c = 1;
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String cantidad = "";
		String sql;
		String busqueda = "";
		String join = "INNER JOIN BDPersonal.dbo.Local_ AS pl ON pl.CodLocal = al.codlocal_pla "
			+ "INNER JOIN BDPersonal.dbo.asociacion AS pa ON pa.id_asoc = pl.id_razon ";
		String select = "	pa.des_asoc, "
			+ "	pa.id_asoc, ";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			if (datos.has("codigoDocente")) {
				sql = " SELECT COUNT(TABLE_NAME) "
					+ " FROM INFORMATION_SCHEMA.Views "
					+ " WHERE TABLE_SCHEMA = 'dbo' "
					+ " AND TABLE_NAME = 'listado_asistencia_porrs' ";  //NOMBRE DE LA VISTA
				pst = con.prepareStatement(sql);
				rSet = pst.executeQuery();
				if (rSet.next()) {
					rs = rSet.getInt(1);
				}
				if (datos.getInt("razonSocial") == 88) {
					select = " 'ACESO' AS  des_asoc , 1 AS id_asoc, ";
					join = " ";
				}
				if (rs != 1) {
					sql = " CREATE VIEW dbo.listado_asistencia_porrs "
						+ "AS "
						+ " SELECT "
						+ "	aa.codasistencia, "
						+ "	aa.codprofesor, "
						+ "	ap.apellido, "
						+ "	ap.nombre, "
						+ "	aa.horai, "
						+ "	aa.horas, "
						+ "	aa.horaiT, "
						+ "	aa.horasT, "
						+ "	aa.fecha_asis, "
						+ "	aa.canthoras / 60 AS horasLaboro, "
						+ "	CAST (aa.canthoras AS INT) % 60 AS minutosLaboro, "
						+ "	CAST ( "
						+ "		CASE "
						+ "		WHEN aa.codsec = 'A' "
						+ "		AND pagado = 0 THEN "
						+ "			pagoa "
						+ "		WHEN aa.codsec = 'B' "
						+ "		AND pagado = 0 THEN "
						+ "			pagob "
						+ "		WHEN aa.codsec = 'C' "
						+ "		AND pagado = 0 THEN "
						+ "			pagoc "
						+ "		WHEN aa.codsec = 'D' "
						+ "		AND pagado = 0 THEN "
						+ "			pagod "
						+ "		WHEN aa.codsec = 'E' "
						+ "		AND pagado = 0 THEN "
						+ "			pagoe "
						+ "		WHEN aa.codsec = 'F' "
						+ "		AND pagado = 0 THEN "
						+ "			pagof "
						+ "		WHEN aa.codsec = 'G' "
						+ "		AND pagado = 0 THEN "
						+ "			pagog "
						+ "		WHEN aa.codsec = 'H' "
						+ "		AND pagado = 0 THEN "
						+ "			pagoh "
						+ "		WHEN aa.codsec IN ( "
						+ "			'A', "
						+ "			'B', "
						+ "			'C', "
						+ "			'D', "
						+ "			'E', "
						+ "			'F', "
						+ "			'G', "
						+ "			'H' "
						+ "		) "
						+ "		AND pagado = 1 "
						+ "		AND aa.costo IS NOT NULL THEN "
						+ "			aa.costo "
						+ "		ELSE "
						+ "			0 "
						+ "		END AS NUMERIC (8, 2) "
						+ "	) AS costo, "
						+ "	aa.codsec, "
						+ "	al.deslocal, "
						+ "	aa.aulas, "
						+ "	aa.dia, "
						+ "	aa.obs, "
						+ "	aa.TipoAsistencia, " + select
						+ "	aa.canthoras "
						+ "FROM "
						+ "	dbo.asistencia AS aa "
						+ "INNER JOIN dbo.profesor AS ap ON aa.codprofesor = ap.codprofesor "
						+ "INNER JOIN dbo.locales AS al ON aa.codlocal = al.codlocal " + join;
					pst = con.prepareStatement(sql);
					rs = pst.executeUpdate();
				} else {
					rs = 0;
				}
				if (rs == 0) {
					String order = " ORDER BY "
						+ " DAY (vw.fecha_asis), 2 ";
					if (datos.getInt("razonSocial") != 0 && datos.getInt("razonSocial") != 88) {
						busqueda = " AND vw.id_asoc = ? ";
					}
					if (datos.has("export")) {
						order = " ORDER BY vw.des_asoc, vw.deslocal, vw.codsec ";
					}
					sql = " SET LANGUAGE 'SPANISH'; "
						+ " SELECT "
						+ "	vw.codasistencia, "
						+ "	SUBSTRING(CONVERT(varchar(12), CONVERT(datetime, CONVERT(varchar(12), SUBSTRING(vw.horai, 1, 5), 111)), 108), 1, 5), "
						+ "	SUBSTRING(CONVERT(varchar(12), CONVERT(datetime, CONVERT(varchar(12), SUBSTRING(vw.horas, 1, 5), 111)), 108), 1, 5), "
						+ "	ISNULL(vw.horaiT, '00:00'), "
						+ "	ISNULL(vw.horasT, '00:00'), "
						+ "	UPPER(DATENAME(dw,vw.fecha_asis)), "
						+ "	CONVERT(VARCHAR, vw.fecha_asis, 103), "
						+ "	vw.codsec, "
						+ "	vw.costo, "
						+ "	LTRIM(STR(vw.horasLaboro,2))+':'+LTRIM(STR(vw.minutosLaboro,2)), "
						+ "	CAST((vw.horasLaboro * costo) AS numeric(8, 2)), "
						+ "	vw.deslocal, "
						+ "	ISNULL(vw.aulas, ' - '), "
						+ "	vw.dia, "
						+ "	ISNULL(vw.obs, ' - '), "
						+ "	ISNULL(vw.TipoAsistencia, '-'), "
						+ "	vw.id_asoc, "
						+ "	vw.des_asoc, "
						+ "	vw.canthoras "
						+ " FROM listado_asistencia_porrs AS vw "
						+ " WHERE "
						+ "	vw.codprofesor = ? " + busqueda
						+ "	AND MONTH (vw.fecha_asis) = ? "
						+ order;
					pst = con.prepareStatement(sql);
					c = 1;
					pst.setString(c++, datos.getString("codigoDocente"));
					if (datos.getInt("razonSocial") != 0 && datos.getInt("razonSocial") != 88) {
						pst.setInt(c++, datos.getInt("razonSocial"));
					}
					pst.setString(c++, datos.getString("mesAsistencia"));
					rSet = pst.executeQuery();
					conta = 1;
					while (rSet.next()) {
						JSONObject obj = new JSONObject();
						c = 1;
						obj.put("numeral", conta++);
						obj.put("codigoAsistencia", rSet.getString(c++));
						obj.put("horaIngreso", rSet.getString(c++));
						obj.put("horaSalida", rSet.getString(c++));
						obj.put("horaIngresoT", rSet.getString(c++));
						obj.put("horaSalidaT", rSet.getString(c++));
						obj.put("diaAsistencias", rSet.getString(c++));
						obj.put("fechaAsistencias", rSet.getString(c++));
						obj.put("seccion", rSet.getString(c++));
						obj.put("costoSeccion", rSet.getString(c++));
						obj.put("horasLaboro", rSet.getString(c++));
						obj.put("montoLaboro", rSet.getString(c++));
						obj.put("sede", rSet.getString(c++));
						obj.put("aulas", rSet.getString(c++));
						obj.put("tipo/dia", rSet.getString(c++));
						obj.put("observacion", rSet.getString(c++));
						obj.put("estadoAsistencia", rSet.getString(c++));
						obj.put("codigoRS", rSet.getInt(c++));
						obj.put("nombreRS", rSet.getString(c++));
						obj.put("minutosLaboro", rSet.getInt(c++));
						listaAsistencias.put(obj);
					}
					sql = " SELECT "
						+ "	CAST(t.monto AS NUMERIC (8,2))s "
						+ "FROM  "
						+ "( "
						+ "	SELECT "
						+ "		SUM( "
						+ "			vw.horasLaboro * costo) AS monto "
						+ "	FROM listado_asistencia_porrs AS vw "
						+ "	WHERE "
						+ "		vw.codprofesor = ? " + busqueda
						+ "		AND MONTH (vw.fecha_asis) = ? "
						+ ") AS t; ";
					pst = con.prepareStatement(sql);
					c = 1;
					pst.setString(c++, datos.getString("codigoDocente"));
					if (datos.getInt("razonSocial") != 0 && datos.getInt("razonSocial") != 88) {
						pst.setInt(c++, datos.getInt("razonSocial"));
					}
					pst.setString(c++, datos.getString("mesAsistencia"));
					rSet = pst.executeQuery();
					if (rSet.next()) {
						cantidad = rSet.getString(1);
					}
					jreturn.put("status", true);
					jreturn.put("listaAsis", listaAsistencias);
					jreturn.put("contaAsis", cantidad);
				} else {
					jreturn.put("status", false);
					jreturn.put("message", "No se encontro la vista solicitada");
					jreturn.put("listaAsis", listaAsistencias);
				}

				sql = " SELECT COUNT(TABLE_NAME) "
					+ "FROM INFORMATION_SCHEMA.Views "
					+ "WHERE TABLE_SCHEMA = 'dbo' "
					+ "AND TABLE_NAME = 'listado_descuentos_porrs' ";
				pst = con.prepareStatement(sql);
				rSet = pst.executeQuery();
				if (rSet.next()) {
					rs = rSet.getInt(1);
				}
				if (rs != 1) {
					sql = " CREATE VIEW dbo.listado_descuentos_porrs "
						+ "AS "
						+ " SELECT "
						+ "	ad.codddes, "
						+ "	ad.codrolasistencia, "
						+ "	ad.codprofesor, "
						+ "	ap.apellido, "
						+ "	ap.nombre, "
						+ "	ad.fecha_asis, "
						+ "	ad.montodes, "
						+ "	ad.motivo, "
						+ "	ad.observacion, "
						+ "	aa.horai, "
						+ "	aa.horas, "
						+ "	al.deslocal, "
						+ "	CAST ( "
						+ "		CASE  "
						+ "			WHEN ad.motivo = 'NO MARCO'  AND ad.codsec = 'I' THEN aa.canthoras "
						+ "			ELSE ad.n_media_hora "
						+ "		END AS NUMERIC (8, 2)) AS cantidadHoras,  "
						+ "	ad.codsec, "
						+ "	aa.horaiT, "
						+ "	aa.horasT, "
						+ "	ap.tiposueldo, "
						+ "	ad.mes, " + select
						+ "	ad.pagado, "
						+ "	CASE ad.motivo "
						+ "		WHEN 'TARDANZA' THEN datediff(MINUTE,CAST(aa.horai AS datetime),CAST(aa.horaiT AS datetime)) "
						+ "		ELSE 0	 "
						+ "	END AS diferencia_dia, "
						+ "	CAST ( "
						+ "		CASE "
						+ "			WHEN ad.codsec = 'A' AND ad.pagado = 0 THEN ap.pagoa "
						+ "			WHEN ad.codsec = 'B' AND ad.pagado = 0 THEN ap.pagob "
						+ "			WHEN ad.codsec = 'C' AND ad.pagado = 0 THEN ap.pagoc "
						+ "			WHEN ad.codsec = 'D' AND ad.pagado = 0 THEN ap.pagod "
						+ "			WHEN ad.codsec = 'E' AND ad.pagado = 0 THEN ap.pagoe "
						+ "			WHEN ad.codsec = 'F' AND ad.pagado = 0 THEN ap.pagof "
						+ "			WHEN ad.codsec = 'G' AND ad.pagado = 0 THEN	ap.pagog "
						+ "			WHEN ad.codsec = 'H' AND ad.pagado = 0 THEN	ap.pagoh "
						+ "			WHEN ad.codsec IN ('A','B','C','D','E','F','G','H')	AND ad.pagado = 1 AND ad.costo IS NOT NULL THEN	ad.costo "
						+ "			WHEN ad.codsec = 'I' AND ad.motivo = 'NO MARCO'	AND ap.tiposueldo = 'MENSUAL' THEN ap.pagoh "
						+ "			WHEN ad.codsec = 'I' AND aa.codsec = 'A' AND ad.motivo = 'NO MARCO' AND ap.tiposueldo IN ('HORAS', 'ADMINISTRATIVO') THEN ap.pagoa "
						+ "			WHEN ad.codsec = 'I' AND aa.codsec = 'B' AND ad.motivo = 'NO MARCO' AND ap.tiposueldo IN ('HORAS', 'ADMINISTRATIVO') THEN ap.pagob "
						+ "			WHEN ad.codsec = 'I' AND aa.codsec = 'C' AND ad.motivo = 'NO MARCO' AND ap.tiposueldo IN ('HORAS', 'ADMINISTRATIVO') THEN ap.pagoc "
						+ "			WHEN ad.codsec = 'I' AND aa.codsec = 'D' AND ad.motivo = 'NO MARCO' AND ap.tiposueldo IN ('HORAS', 'ADMINISTRATIVO') THEN ap.pagod "
						+ "			WHEN ad.codsec = 'I' AND aa.codsec = 'E' AND ad.motivo = 'NO MARCO' AND ap.tiposueldo IN ('HORAS', 'ADMINISTRATIVO') THEN ap.pagoe "
						+ "			WHEN ad.codsec = 'I' AND aa.codsec = 'F' AND ad.motivo = 'NO MARCO' AND ap.tiposueldo IN ('HORAS', 'ADMINISTRATIVO') THEN ap.pagof "
						+ "			WHEN ad.codsec = 'I' AND aa.codsec = 'G' AND ad.motivo = 'NO MARCO' AND ap.tiposueldo IN ('HORAS', 'ADMINISTRATIVO') THEN ap.pagog "
						+ "			WHEN ad.codsec = 'I' AND aa.codsec = 'H' AND ad.motivo = 'NO MARCO' AND ap.tiposueldo IN ('HORAS', 'ADMINISTRATIVO') THEN ap.pagoh "
						+ "			WHEN ad.codsec = 'I' AND ad.motivo = 'TARDANZA' AND ap.tiposueldo = 'ADMINISTRATIVO' THEN ap.pagod "
						+ "			ELSE 0 "
						+ "		END AS NUMERIC (8, 2)) AS costo, "
						+ "	( "
						+ "		SELECT ISNULL( "
						+ "		(SELECT "
						+ "			SUM(datediff(MINUTE,CAST(horai AS datetime),CAST (horaiT AS datetime)))AS diferencia "
						+ "		FROM "
						+ "			descuento b "
						+ "		INNER JOIN asistencia a ON b.codrolasistencia = a.codasistencia "
						+ "		WHERE a.codprofesor = ap.codprofesor "
						+ "		AND mes = ad.mes AND motivo = 'TARDANZA'), 0 "
						+ "		) "
						+ "	) AS diferencia_mes "
						+ "FROM "
						+ "	descuento AS ad "
						+ "INNER JOIN profesor AS ap ON ad.codprofesor = ap.codprofesor "
						+ "INNER JOIN asistencia AS aa ON ad.codrolasistencia = aa.codasistencia "
						+ "INNER JOIN locales AS al ON aa.codlocal = al.codlocal " + join;
					pst = con.prepareStatement(sql);
					rs = pst.executeUpdate();
				} else {
					rs = 0;
				}
				if (rs == 0) {
					if (datos.getInt("razonSocial") != 0 && datos.getInt("razonSocial") != 88) {
						busqueda = " AND vw.id_asoc = ? ";
					}
					sql = " SET LANGUAGE 'SPANISH'; "
						+ " SELECT "
						+ "	vw.codddes, "
						+ "	vw.codrolasistencia, "
						+ "	vw.horai, "
						+ "	vw.horas, "
						+ "	vw.horaiT, "
						+ "	CONVERT(VARCHAR, vw.fecha_asis, 103), "
						+ "	CAST ( "
						+ "		CASE  "
						+ "        WHEN vw.motivo IN ('TARDANZA') AND vw.diferencia_mes > 20 THEN (vw.cantidadHoras / 60.00) * vw.costo\n"
						+ "		WHEN vw.motivo IN ('TARDANZA') AND vw.diferencia_mes <= 20 THEN ((vw.cantidadHoras / 60.00) * vw.costo) / 2\n"
						+ "		WHEN VW.motivo NOT IN ('NO FIRMO','NO ENTREGO REGISTRO', 'TARDANZA') THEN (vw.cantidadHoras / 60.00) * vw.costo\n"
						+ "		WHEN vw.motivo = 'NO FIRMO' THEN	10\n"
						+ "		WHEN vw.motivo = 'NO ENTREGO REGISTRO' THEN		20\n"
						+ "		ELSE	0"
						+ "		END	 AS NUMERIC (8, 2)) AS descuento, "
						+ "	vw.deslocal, "
						+ "	vw.codsec, "
						+ "	vw.motivo, "
						+ "	vw.observacion "
						+ "FROM "
						+ "	listado_descuentos_porrs AS vw "
						+ "WHERE vw.codprofesor = ? "
						+ "AND vw.mes = ?		 " + busqueda
						+ "ORDER BY vw.fecha_asis; ";
					pst = con.prepareStatement(sql);
					c = 1;
					pst.setString(c++, datos.getString("codigoDocente"));
					pst.setString(c++, datos.getString("mesAsistencia"));
					if (datos.getInt("razonSocial") != 0 && datos.getInt("razonSocial") != 88) {
						pst.setInt(c++, datos.getInt("razonSocial"));
					}
					System.out.println("QUERY ---> " + pst);
					System.out.println("QUERY ---> " + sql);
					rSet = pst.executeQuery();
					conta = 1;
					while (rSet.next()) {
						JSONObject obj = new JSONObject();
						c = 1;
						obj.put("numeral", conta++);
						obj.put("codigoDescuento", rSet.getString(c++));
						obj.put("codigoAsistencia", rSet.getString(c++));
						obj.put("horaIngreso", rSet.getString(c++));
						obj.put("horaSalida", rSet.getString(c++));
						obj.put("horaIngresoT", rSet.getString(c++));
						obj.put("fechaAsistencias", rSet.getString(c++));
						obj.put("montoDescuento", rSet.getString(c++));
						obj.put("sede", rSet.getString(c++));
						obj.put("seccion", rSet.getString(c++));
						obj.put("motivo", rSet.getString(c++));
						obj.put("observacion", rSet.getString(c++));
						listaDescuentos.put(obj);
					}
					sql = " SELECT  "
						+ "	SUM(t.descuento) "
						+ "FROM  "
						+ "	( "
						+ "	SELECT "
						+ "		CAST ( "
						+ "			CASE  "
						+ "        WHEN vw.motivo IN ('TARDANZA') AND vw.diferencia_mes > 20 THEN (vw.cantidadHoras / 60.00) * vw.costo\n"
						+ "		WHEN vw.motivo IN ('TARDANZA') AND vw.diferencia_mes <= 20 THEN ((vw.cantidadHoras / 60.00) * vw.costo) / 2\n"
						+ "		WHEN VW.motivo NOT IN ('NO FIRMO','NO ENTREGO REGISTRO', 'TARDANZA') THEN (vw.cantidadHoras / 60.00) * vw.costo\n"
						+ "		WHEN vw.motivo = 'NO FIRMO' THEN	10\n"
						+ "		WHEN vw.motivo = 'NO ENTREGO REGISTRO' THEN		20\n"
						+ "		ELSE	0"
						+ "			END AS NUMERIC (8, 2)) AS descuento "
						+ "	FROM "
						+ "		listado_descuentos_porrs AS vw "
						+ "	WHERE vw.codprofesor = ? "
						+ "	AND vw.mes = ? " + busqueda
						+ "	)AS t; ";
					pst = con.prepareStatement(sql);
					System.out.println("QUERY TOTAL CMSMSMSMSMSS" + sql);
					c = 1;
					pst.setString(c++, datos.getString("codigoDocente"));
					pst.setString(c++, datos.getString("mesAsistencia"));
					if (datos.getInt("razonSocial") != 0 && datos.getInt("razonSocial") != 88) {
						pst.setInt(c++, datos.getInt("razonSocial"));
					}
					rSet = pst.executeQuery();
					if (rSet.next()) {
						cantidad = rSet.getString(1);
					}
					jreturn.put("status", true);
					jreturn.put("listaDesc", listaDescuentos);
					jreturn.put("contaDesc", cantidad);
				} else {
					jreturn.put("status", false);
					jreturn.put("message", "No se encontro la vista solicitada");
					jreturn.put("listaDesc", listaDescuentos);
				}
			} else {
				jreturn.put("status", false);
				jreturn.put("message", "Debe seleccionar un docente ");
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		return jreturn;
	}

	@Override
	public JSONObject listarMontosPorPago(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql = " select COUNT(*) "
				+ "  from information_schema.routines  "
				+ " where routine_type = 'PROCEDURE' "
				+ "AND specific_name = 'LISTAR_MONTOS_CODPROFESOR_MES_V2' "
				+ "AND specific_schema = 'dbo' ";
			pst = con.prepareStatement(sql);
			rSet = pst.executeQuery();
			if (rSet.next()) {
				rs = rSet.getInt(1);
			}
			if (rs != 1) {
				sql = " CREATE  PROC [dbo].[LISTAR_MONTOS_CODPROFESOR_MES_V2] "
					+ "@codprofesor CHAR(8), "
					+ "@MES INT "
					+ "AS "
					+ "select  ASISTENCIA.codprofesor, SUM(canthoras) AS 'MINUTOS' ,SUM(canthoras)/60 AS 'HORAS'  ,ASISTENCIA.codsec "
					+ ", "
					+ "CAST ( "
					+ "	CASE  "
					+ "		WHEN asistencia.codsec = 'A' and pagado = 0 THEN (SELECT pagoa FROM PROFESOR where codprofesor =@codprofesor  )  "
					+ "		WHEN asistencia.codsec = 'B' and pagado = 0 THEN (SELECT pagob FROM PROFESOR where codprofesor =@codprofesor )  "
					+ "		WHEN asistencia.codsec = 'C' and pagado = 0 THEN (SELECT pagoc FROM PROFESOR where codprofesor =@codprofesor )	 "
					+ "		WHEN asistencia.codsec = 'D' and pagado = 0 THEN (SELECT pagod FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'E' and pagado = 0 THEN (SELECT pagoe FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'F' and pagado = 0 THEN (SELECT pagof FROM PROFESOR where codprofesor =@codprofesor )	 "
					+ "		WHEN asistencia.codsec = 'G' and pagado = 0 THEN (SELECT pagog FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'H' and pagado = 0 THEN (SELECT pagoh FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'J' and pagado = 0 THEN (SELECT pagoj FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'K' and pagado = 0 THEN (SELECT pagok FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec in ('A','B','C','D','E','F','G','H','J','K') and pagado = 1 THEN costo "
					+ "	END AS NUMERIC (8,2)) AS 'PAGO_HORA', "
					+ "CAST ( "
					+ "	CASE  "
					+ "		WHEN asistencia.codsec = 'A' and pagado = 0 THEN (SELECT pagoa * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor  )  "
					+ "		WHEN asistencia.codsec = 'B' and pagado = 0 THEN (SELECT pagob * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor )  "
					+ "		WHEN asistencia.codsec = 'C' and pagado = 0 THEN (SELECT pagoc * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor )	 "
					+ "		WHEN asistencia.codsec = 'D' and pagado = 0 THEN (SELECT pagod * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'E' and pagado = 0 THEN (SELECT pagoe * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'F' and pagado = 0 THEN (SELECT pagof * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor )	 "
					+ "		WHEN asistencia.codsec = 'G' and pagado = 0 THEN (SELECT pagog * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'H' and pagado = 0 THEN (SELECT pagoh * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'J' and pagado = 0 THEN (SELECT pagoj * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec = 'K' and pagado = 0 THEN (SELECT pagok * (SUM(canthoras)/60) FROM PROFESOR where codprofesor =@codprofesor ) "
					+ "		WHEN asistencia.codsec in ('A','B','C','D','E','F','G','H','J','K') and pagado = 1 THEN costo * SUM(canthoras)/60 "
					+ "	END AS NUMERIC (8,2)) AS 'MONTO' "
					+ "from asistencia INNER JOIN PROFESOR ON ( asistencia.codprofesor   = PROFESOR.codprofesor) "
					+ "WHERE ASISTENCIA.codprofesor = @codprofesor and month(fecha_asis) = @MES    "
					+ "GROUP BY codsec , ASISTENCIA.codprofesor,pagado,costo ";
				System.out.println("Query ---> " + sql);
				pst = con.prepareStatement(sql);
				pst.executeUpdate();
			}
			sql = " {CALL LISTAR_MONTOS_CODPROFESOR_MES_V2 (?,?)} ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("codigoDocente"));
			pst.setInt(2, datos.getInt("mesAsistencia"));
			rSet = pst.executeQuery();
			int conta = 1;
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				int c = 1;
				obj.put("numeral", conta++);
				obj.put("codigoDocente", rSet.getString(c++));
				obj.put("minutos", rSet.getString(c++));
				obj.put("horas", rSet.getString(c++));
				obj.put("seccion", rSet.getString(c++));
				obj.put("monto", rSet.getString(c++));
				obj.put("subtotal", rSet.getString(c++));
				lista.put(obj);
			}
			response.setStatus(lista.length() >= 1);
			response.setResults(lista);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarResumenPagos(JSONObject datos) throws Exception {
		System.out.println("PARAMETROS ---> " + datos);
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql = " select\n"
				+ "	tx.dia,\n"
				+ "	LTRIM(tx.horas) + ':' + LTRIM(tx.minutos),\n"
				+ "	tx.totalMonto\n"
				+ "from (\n"
				+ "select \n"
				+ "	t.dia as dia,\n"
				+ "	t.totalHoras/60 as horas,\n"
				+ "	CAST(t.totalHoras AS INT)%60 as minutos,\n"
				+ "	CAST(t.totalMonto AS NUMERIC(8,2)) as totalMonto\n"
				+ "from (\n"
				+ "select \n"
				+ "	vw.dia as dia, \n"
				+ "	CAST(SUM(vw.canthoras) AS INT) as totalHoras,\n"
				+ "	SUM(vw.horasLaboro * vw.costo) as totalMonto\n"
				+ "from listado_asistencia_porrs as vw\n"
				+ "WHERE vw.codprofesor = ?\n"
				+ "AND MONTH(vw.fecha_asis) = ?\n"
				+ "GROUP BY vw.dia ) as t ) as tx  ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("codigoDocente"));
			pst.setInt(2, datos.getInt("mesAsistencia"));
			System.out.println("QUERY ---> " + pst);
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("tipoAsistencia", rSet.getString(1));
				obj.put("totalHoras", rSet.getString(2));
				obj.put("montoTotal", rSet.getString(3));
				lista.put(obj);
			}
			response.setResults(lista);
			sql = "select\n"
				+ "	LTRIM(STR(tx.horas, 3)) + ':' + LTRIM(STR(tx.minutos, 3)),\n"
				+ "	tx.totalMonto\n"
				+ "from (\n"
				+ "select \n"
				+ "	STR(t.totalHoras/60, 3) as horas,\n"
				+ "	CAST(t.totalHoras AS INT)%60 as minutos,\n"
				+ "	CAST(t.totalMonto AS NUMERIC(8,2)) as totalMonto\n"
				+ "from (\n"
				+ "select \n"
				+ "	SUM(vw.canthoras) as totalHoras,\n"
				+ "	SUM(vw.horasLaboro * vw.costo) as totalMonto\n"
				+ "from listado_asistencia_porrs as vw\n"
				+ "WHERE vw.codprofesor = ?\n"
				+ "AND MONTH(vw.fecha_asis) = ?\n"
				+ "GROUP BY vw.codprofesor ) as t ) as tx ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("codigoDocente"));
			pst.setInt(2, datos.getInt("mesAsistencia"));
			System.out.println("QUERY ---> " + pst);
			rSet = pst.executeQuery();
			JSONObject obj = new JSONObject();
			if (rSet.next()) {
				obj.put("totalHoras", rSet.getString(1));
				obj.put("montoTotal", rSet.getString(2));
			}
			response.setData(obj);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarResumenRS(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql = " SELECT  "
				+ "	t.deslocal, "
				+ "	STR(t.totalHoras/60,2)+':'+STR(t.totalHoras%60,2), "
				+ "	CAST(t.monto AS NUMERIC(8,2)) "
				+ " FROM ( "
				+ "	SELECT  "
				+ "		vw.deslocal, "
				+ "		CAST((SUM(vw.canthoras)) AS INT) AS totalHoras, "
				+ "		SUM(vw.horasLaboro * costo) AS monto "
				+ "	FROM listado_asistencia_porrs AS vw "
				+ "	WHERE "
				+ "		vw.codprofesor = ? "
				+ "		AND MONTH (vw.fecha_asis) = ? "
				+ "		AND vw.id_asoc = ? "
				+ "	GROUP BY vw.deslocal "
				+ " ) AS t "
				+ " ORDER BY 1 ASC ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("codigoDocente"));
			pst.setInt(2, datos.getInt("mesAsistencia"));
			pst.setInt(3, datos.getInt("razonSocial"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("nombreConcepto", Objects.toString(rSet.getString(1), "---"));
				obj.put("totalHoras", Objects.toString(rSet.getString(2), "---"));
				obj.put("montoTotal", Objects.toString(rSet.getString(3), " ---"));
				obj.put("tipoRegistro", 1);
				lista.put(obj);
			}
			if (lista.length() > 0 == false) {
				JSONObject obj = new JSONObject();
				obj.put("nombreConcepto", "---");
				obj.put("totalHoras", "---");
				obj.put("montoTotal", "---");
				obj.put("tipoRegistro", 1);
				lista.put(obj);
			}
			sql = " SELECT  "
				+ "	STR(x.totalHoras/60,2)+':'+STR(x.totalHoras%60,2), "
				+ "	CAST (x.totalMonto AS NUMERIC(8, 2)) "
				+ "FROM ( "
				+ "	SELECT  "
				+ "		CAST((SUM(t.totalHoras)) AS INT) AS totalHoras, "
				+ "		SUM(t.monto) AS totalMonto "
				+ "	FROM ( "
				+ "		SELECT  "
				+ "			vw.deslocal, "
				+ "			SUM(vw.canthoras) AS totalHoras, "
				+ "			SUM(vw.horasLaboro * costo) AS monto "
				+ "		FROM listado_asistencia_porrs AS vw "
				+ "		WHERE "
				+ "			vw.codprofesor = ? "
				+ "			AND MONTH (vw.fecha_asis) = ? "
				+ "			AND vw.id_asoc = ? "
				+ "		GROUP BY vw.deslocal "
				+ "	) AS t "
				+ ") AS x ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("codigoDocente"));
			pst.setInt(2, datos.getInt("mesAsistencia"));
			pst.setInt(3, datos.getInt("razonSocial"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("nombreConcepto", "TOTAL ASISTENCIAS: ");
				obj.put("totalHoras", Objects.toString(rSet.getString(1), "---"));
				obj.put("montoTotal", Objects.toString(rSet.getString(2), "---"));
				obj.put("tipoRegistro", 2);
				lista.put(obj);
			}
			sql = " SELECT  "
				+ "	STR(x.totalHoras/60,2)+':'+STR(x.totalHoras%60,2), "
				+ "	x.totalMonto "
				+ "FROM ( "
				+ "SELECT  "
				+ "	SUM(t.descuento) AS totalMonto, "
				+ "	CAST((SUM(t.cantidadHoras)) AS INT) AS totalHoras "
				+ "FROM  "
				+ "	( "
				+ "	SELECT "
				+ "		CAST ( "
				+ "			CASE  "
				+ "				WHEN vw.motivo NOT IN ('NO FIRMO', 'NO ENTREGO REGISTRO') AND vw.diferencia_mes > 20 THEN (vw.cantidadHoras/60.00)*vw.costo "
				+ "				WHEN vw.motivo NOT IN ('NO FIRMO', 'NO ENTREGO REGISTRO') AND vw.diferencia_mes <= 20 THEN ((vw.cantidadHoras/60.00)*vw.costo)/2 "
				+ "				WHEN vw.motivo = 'NO FIRMO' THEN 10 "
				+ "				WHEN vw.motivo = 'NO ENTREGO REGISTRO' THEN 20 "
				+ "				ELSE 0 "
				+ "			END AS NUMERIC (8, 2)) AS descuento, "
				+ "			vw.cantidadHoras "
				+ "	FROM "
				+ "		listado_descuentos_porrs AS vw "
				+ "	WHERE vw.codprofesor = ? "
				+ "	AND vw.mes = ? "
				+ "	AND vw.id_asoc = ? "
				+ "	)AS t "
				+ ") AS x ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("codigoDocente"));
			pst.setInt(2, datos.getInt("mesAsistencia"));
			pst.setInt(3, datos.getInt("razonSocial"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("nombreConcepto", "TOTAL DESCUENTOS: ");
				obj.put("totalHoras", Objects.toString(rSet.getString(1), "---"));
				obj.put("montoTotal", Objects.toString(rSet.getString(2), "---"));
				obj.put("tipoRegistro", 2);
				lista.put(obj);
			}
			sql = " SELECT  \n"
				+ "		STR(z.totalHoras/60,2)+':'+STR(z.totalHoras%60,2),\n"
				+ "		z.totalMonto \n"
				+ "FROM ( \n"
				+ "		SELECT \n"
				+ "			ISNULL(y.totalHoras, 0) - ISNULL(x.totalHoras , 0) AS totalHoras,\n"
				+ "			ISNULL(y.totalMonto, 0.0) - ISNULL(x.totalMonto, 0.0) AS totalMonto\n"
				+ "		FROM\n"
				+ "		(SELECT  \n"
				+ "			1 AS ki,\n"
				+ "			CAST(SUM(t.totalHoras) AS INT) AS totalHoras, \n"
				+ "			CAST(SUM(t.monto) AS NUMERIC(8,2)) AS totalMonto \n"
				+ "		FROM ( \n"
				+ "			SELECT  \n"
				+ "				vw.deslocal, \n"
				+ "				SUM(vw.canthoras) AS totalHoras, \n"
				+ "				SUM(vw.horasLaboro * costo) AS monto  \n"
				+ "			FROM listado_asistencia_porrs AS vw \n"
				+ "			WHERE vw.codprofesor = ? \n"
				+ "			AND MONTH (vw.fecha_asis) = ? \n"
				+ "			AND vw.id_asoc = ? \n"
				+ "		GROUP BY vw.deslocal \n"
				+ "		) AS t ) AS y\n"
				+ "		INNER JOIN\n"
				+ "		(SELECT  	\n"
				+ "			1 AS ki,\n"
				+ "			SUM(t.descuento) AS totalMonto, \n"
				+ "			CAST(SUM(t.cantidadHoras) AS INT) AS totalHoras \n"
				+ "		FROM ( \n"
				+ "			SELECT CAST ( \n"
				+ "					CASE  \n"
				+ "						 WHEN vw.motivo NOT IN ('NO FIRMO', 'NO ENTREGO REGISTRO') AND vw.diferencia_mes > 20 THEN (vw.cantidadHoras/60.00)*vw.costo \n"
				+ "						 WHEN vw.motivo NOT IN ('NO FIRMO', 'NO ENTREGO REGISTRO') AND vw.diferencia_mes <= 20 THEN ((vw.cantidadHoras/60.00)*vw.costo)/2 \n"
				+ "						 WHEN vw.motivo = 'NO FIRMO' THEN 10 \n"
				+ "						 WHEN vw.motivo = 'NO ENTREGO REGISTRO' THEN 20 \n"
				+ "						 ELSE 0 \n"
				+ "					END AS NUMERIC (8, 2)) AS descuento, \n"
				+ "					vw.cantidadHoras \n"
				+ "			FROM listado_descuentos_porrs AS vw \n"
				+ "			WHERE vw.codprofesor = ? \n"
				+ "			AND vw.mes = ?	\n"
				+ "			AND vw.id_asoc =? \n"
				+ "		)AS t ) AS x\n"
				+ "		ON x.ki = y.ki	\n"
				+ ") AS z ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("codigoDocente"));
			pst.setInt(2, datos.getInt("mesAsistencia"));
			pst.setInt(3, datos.getInt("razonSocial"));
			pst.setString(4, datos.getString("codigoDocente"));
			pst.setInt(5, datos.getInt("mesAsistencia"));
			pst.setInt(6, datos.getInt("razonSocial"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("nombreConcepto", "TOTAL NETO: ");
				obj.put("totalHoras", Objects.toString(rSet.getString(1), "---"));
				obj.put("montoTotal", Objects.toString(rSet.getString(2), "---"));
				obj.put("tipoRegistro", 3);
				lista.put(obj);
			}
			response.setStatus(lista.length() > 0);
			response.setResults(lista);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarDetalleDescuento(JSONObject datos) throws Exception {
		JSONObject jreturn;
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql = " SELECT\n"
				+ "	a.codddes AS codigo_descuento,\n"
				+ "	ISNULL(\n"
				+ "		CONVERT (\n"
				+ "			VARCHAR (10),\n"
				+ "			d.fecha_asis,\n"
				+ "			103\n"
				+ "		),\n"
				+ "		'VACIO'\n"
				+ "	) AS fecha_asistencia,\n"
				+ "	a.codrolasistencia AS codigo_rol_asistencia,\n"
				+ "	a.codprofesor AS codigo_profesor,\n"
				+ "	a.mes AS mes,\n"
				+ "	a.motivo AS motivo,\n"
				+ "	isnull(\n"
				+ "		CAST (a.montodes AS VARCHAR),\n"
				+ "		''\n"
				+ "	) AS monto_des,\n"
				+ "	a.pagado AS pagado,\n"
				+ "	a.observacion AS obvservacion,\n"
				+ "	a.n_media_hora AS n_media_hora,\n"
				+ "	a.codsec AS codigo_seccion,\n"
				+ "	a.codusuario AS codigo_usuario,\n"
				+ "	a.codlocal AS codigo_local,\n"
				+ "	isnull(CAST(a.costo AS VARCHAR), '') AS costo\n"
				+ "FROM\n"
				+ "	dbo.descuento AS a\n"
				+ "INNER JOIN dbo.profesor AS b ON a.codprofesor = b.codprofesor\n"
				+ "INNER JOIN dbo.locales AS c ON a.codlocal = c.codlocal\n"
				+ "INNER JOIN dbo.asistencia AS d ON a.codrolasistencia = d.codasistencia\n"
				+ "WHERE\n"
				+ "	a.codprofesor = ?\n"
				+ "AND MONTH (a.fecha_asis) = ?\n"
				+ "AND a.codddes = ? ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("codigoProfesor"));
			pst.setInt(2, datos.getInt("mesDescuento"));
			pst.setString(3, datos.getString("codigoDescuento"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				int c = 1;
				JSONObject obj = new JSONObject();
				obj.put("codigoDescuento", rSet.getString(c++));
				obj.put("fechaAsistencia", rSet.getString(c++));
				obj.put("rolAsistencia", rSet.getString(c++));
				obj.put("codigoProfesor", rSet.getString(c++));
				obj.put("mesDescuento", rSet.getString(c++));
				obj.put("motivoDescuento", rSet.getString(c++));
				obj.put("montoDescuento", rSet.getString(c++));
				obj.put("estadoPagado", rSet.getString(c++));
				obj.put("observacionDescuento", rSet.getString(c++));
				obj.put("minutosDescuento", rSet.getString(c++));
				obj.put("codigoSeccion", rSet.getString(c++));
				obj.put("codigoUsuario", rSet.getString(c++));
				obj.put("codigoLocal", rSet.getString(c++));
				obj.put("costoDescuento", rSet.getString(c++));
				lista.put(obj);
			}
			response.setStatus(lista.length() > 0);
			response.setResults(lista);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		return new JSONObject(response);
	}
}
