/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so.winwebdocentes.sqlserverDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Calendar;
import org.json.JSONArray;
import org.json.JSONObject;
import so.winwebdocentes.DAO.BaseOpcionDAO;
import so.winwebdocentes.utilities.ResponseHelper;

/**
 *
 * @author Felipe Escala
 */
public class BaseOpcionSqlServerDAO implements BaseOpcionDAO {

	@Override
	public JSONObject listarAniosDB(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql
				= "select top 1 "
				+ "cast(substring(name, 10, len(name)) as integer) anio "
				+ "from master.dbo.sysdatabases "
				+ "where name like 'sacoolive%' "
				+ "order by cast(substring(name, 10, len(name)) as integer) desc; ";
			pst = con.prepareStatement(sql);
			rSet = pst.executeQuery();
			if (rSet.next()) {
				rs = rSet.getInt(1);
			}
			sql = "select "
				+ "substring(name, 10, len(name)) "
				+ "from master.dbo.sysdatabases "
				+ "where name like 'sacoolive%';";
			pst = con.prepareStatement(sql);
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("anio", rSet.getInt(1));
				obj.put("state", rSet.getInt(1) == rs);
				lista.put(obj);
			}
			response.setStatus(lista.length() > 0);
			response.setResults(lista);
			response.setMessage(lista.length() > 0 ? "Correcto" : "No hay data disponible");
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarMesesActivos(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql
				= "select top 1 MAX(MONTH(a.fecha_asis)) as ultimo_mes_activo "
				+ "from asistencia a "
				+ "group by MONTH(a.fecha_asis) "
				+ "order by MONTH(a.fecha_asis) desc;";
			pst = con.prepareStatement(sql);
			rSet = pst.executeQuery();
			if (rSet.next()) {
				rs = rSet.getInt(1);
			}
			sql
				= "set language 'spanish'; "
				+ "select "
				+ "month(a.fecha_asis) as numero_mes, "
				+ "upper(datename(mm, a.fecha_asis)) as nombre_mes "
				+ "from asistencia a "
				+ "group by month(a.fecha_asis), upper(datename(mm, a.fecha_asis)) "
				+ "order by month(a.fecha_asis);";
			pst = con.prepareStatement(sql);
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("numeroMes", rSet.getInt(1));
				obj.put("nombreMes", rSet.getString(2));
				obj.put("state", rSet.getInt(1) == rs);
				lista.put(obj);
			}
			response.setStatus(lista.length() > 0);
			response.setResults(lista);
			response.setMessage(lista.length() > 0 ? "Correcto" : "No hay data disponible");
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

}
