package so.winwebdocentes.sqlserverDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Calendar;
import org.json.JSONArray;
import org.json.JSONObject;
import so.winwebdocentes.beans.ReporteAsistProfesoresPorMes;
import so.winwebdocentes.DAO.ReporteAsistProfesoresPorMesDAO;
import so.winwebdocentes.utilities.GeneralMethods;
import so.winwebdocentes.utilities.ResponseHelper;

public class SQLReporteAsistProfesoresPorMesDAO implements ReporteAsistProfesoresPorMesDAO {

	@Override
	public ArrayList<ReporteAsistProfesoresPorMes> Listar_ReporteAsistProfesoresPorMes(String dbanio, String mes) throws Exception {
		ArrayList<ReporteAsistProfesoresPorMes> Listar_ReporteAsistProfesoresPorMes = new ArrayList<>();
		String base = "sacoolive" + dbanio;
		Connection cnx = SqlServerDAOFactory.obtenerConexion(base, dbanio);
		Statement st = cnx.createStatement();
		GeneralMethods.validarVistaExportar(st);
		String sql = "select * from vista_exportar_todos_profesores_V2 where nro_mes = '" + mes + "' order by abreviatura_asociacion;";
		ResultSet rs = st.executeQuery(sql);
		while (rs.next()) {
			ReporteAsistProfesoresPorMes rp = new ReporteAsistProfesoresPorMes();
			rp.setApellidos(rs.getString("apellidos"));
			rp.setNombres(rs.getString("nombres"));
			rp.setDni(rs.getString("dni"));
			rp.setAbreviatura_asociacion(rs.getString("abreviatura_asociacion"));
			rp.setNombre_asociacion(rs.getString("nombre_asociacion"));
			rp.setNombre_local(rs.getString("nombre_local"));
			rp.setAcumulado_cantidad_minutos(rs.getString("acumulado_cantidad_minutos"));
			rp.setAcumulado_horas(rs.getString("acumulado_horas"));
			rp.setAcumulado_minutos(rs.getString("acumulado_minutos"));
			rp.setCodsec(rs.getString("codsec"));
			rp.setMonto_asistencia(rs.getString("monto_asistencia"));
			rp.setFecha_asistencia(rs.getString("fecha_asistencia"));
			rp.setNombre_mes(rs.getString("nombre_mes"));
			rp.setNro_mes(rs.getString("nro_mes"));
			Listar_ReporteAsistProfesoresPorMes.add(rp);
		}
		return Listar_ReporteAsistProfesoresPorMes;
	}

	@Override
	public ArrayList<ReporteAsistProfesoresPorMes> Listar_NetosReporteAsistProfesoresPorMes(String dbanio, String mes) throws Exception {
		ArrayList<ReporteAsistProfesoresPorMes> Listar_NetosReporteAsistProfesoresPorMes = new ArrayList<>();
		String base = "sacoolive" + dbanio;
		Connection cnx = SqlServerDAOFactory.obtenerConexion(base, dbanio);
		Statement st = cnx.createStatement();
		GeneralMethods.validarVistaExportar(st);
		String sql
			= "select  "
			+ "cast(sum(v.acumulado_cantidad_minutos) as integer) as neto_acumulado_cantidad_minutos, "
			+ "sum(v.acumulado_horas) as neto_acumulado_horas, "
			+ "sum(v.acumulado_minutos) as neto_acumulado_minutos, "
			+ "sum(v.monto_asistencia) as neto_monto_asistencia "
			+ "from vista_exportar_todos_profesores_V2 v "
			+ "where v.nro_mes = '" + mes + "'; ";
		System.out.println("Listar_NetosReporteAsistProfesoresPorMes => vista_exportar_todos_profesores filtracion por mes => " + sql);
		ResultSet rs = st.executeQuery(sql);
		while (rs.next()) {
			ReporteAsistProfesoresPorMes rp = new ReporteAsistProfesoresPorMes();
			rp.setNeto_acumulado_cantidad_minutos(rs.getString("neto_acumulado_cantidad_minutos"));
			rp.setNeto_acumulado_horas(rs.getString("neto_acumulado_horas"));
			rp.setNeto_acumulado_minutos(rs.getString("neto_acumulado_minutos"));
			rp.setNeto_monto_asistencia(rs.getString("neto_monto_asistencia"));
			Listar_NetosReporteAsistProfesoresPorMes.add(rp);
		}
		return Listar_NetosReporteAsistProfesoresPorMes;
	}

//    public static void main(String[] args) throws Exception {
//        SQLReporteAsistProfesoresPorMesDAO metodo = new SQLReporteAsistProfesoresPorMesDAO();
//        System.out.println("" + metodo.Listar_ReporteAsistProfesoresPorMes("2017", "5").get(0).getAbreviatura_asociacion());
//    }
	@Override
	public JSONObject listarDescuentosMensual(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONArray lista = new JSONArray();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql = " SELECT\n"
				+ "	t.codigo,\n"
				+ "	t.personal,\n"
				+ "	SUM (t.descuento)\n"
				+ "FROM\n"
				+ "	(\n"
				+ "		SELECT\n"
				+ "			vw.codprofesor AS codigo,\n"
				+ "			pr.apellido + ' ' + pr.nombre AS personal,\n"
				+ "			CAST (\n"
				+ "				CASE\n"
				+ "				WHEN vw.motivo IN ('TARDANZA')\n"
				+ "				AND vw.diferencia_mes > 20 THEN\n"
				+ "					(vw.cantidadHoras / 60.00) * vw.costo\n"
				+ "				WHEN vw.motivo IN ('TARDANZA')\n"
				+ "				AND vw.diferencia_mes <= 20 THEN\n"
				+ "					(\n"
				+ "						(vw.cantidadHoras / 60.00) * vw.costo\n"
				+ "					) / 2\n"
				+ "				WHEN VW.motivo NOT IN (\n"
				+ "					'NO FIRMO',\n"
				+ "					'NO ENTREGO REGISTRO',\n"
				+ "					'TARDANZA'\n"
				+ "				) THEN\n"
				+ "					(vw.cantidadHoras / 60.00) * vw.costo\n"
				+ "				WHEN vw.motivo = 'NO FIRMO' THEN\n"
				+ "					10\n"
				+ "				WHEN vw.motivo = 'NO ENTREGO REGISTRO' THEN\n"
				+ "					20\n"
				+ "				ELSE\n"
				+ "					0\n"
				+ "				END AS NUMERIC (8, 2)\n"
				+ "			) AS descuento\n"
				+ "		FROM\n"
				+ "			listado_descuentos_porrs AS vw\n"
				+ "		INNER JOIN profesor AS pr ON pr.codprofesor = vw.codprofesor\n"
				+ "		WHERE\n"
				+ "			vw.mes = ? \n"
				+ "	) AS t\n"
				+ "GROUP BY\n"
				+ "	t.codigo, t.personal ";
			pst = con.prepareStatement(sql);
			pst.setInt(1, datos.getInt("mesReporte"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("codigoDocente", rSet.getString(1));
				obj.put("nombreDocente", rSet.getString(2));
				obj.put("cantidadHoras", rSet.getString(3));
				lista.put(obj);
			}
			response.setStatus(lista.length() > 0);
			response.setMessage(lista.length() > 0 ? "Consulta correcta" : "Error en la consulta");
			response.setResults(lista);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		return new JSONObject(response);
	}
}
