/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so.winwebdocentes.sqlserverDAO;

import io.github.cdimascio.dotenv.Dotenv;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import so.winwebdocentes.DAO.AsistenciaDAO;
import so.winwebdocentes.DAO.BaseOpcionDAO;
import so.winwebdocentes.DAO.DAOFactory;
import so.winwebdocentes.DAO.DocenteDAO;
import so.winwebdocentes.DAO.ReporteAsistProfesoresPorAnioDAO;
import so.winwebdocentes.DAO.ReporteAsistProfesoresPorMesDAO;
import so.winwebdocentes.utilities.OsUtils;

/**
 *
 * @author Felipe Escala
 */
public class SqlServerDAOFactory extends DAOFactory {

	static {
		try {
			Class.forName("net.sourceforge.jtds.jdbc.Driver");
		} catch (ClassNotFoundException ex) {
			ex.printStackTrace();
		}
	}

	public static Connection obtenerConexion(String base, String... year) {
		Connection connection = null;
		Dotenv dotenv = Dotenv
			.configure()
			.directory(OsUtils.getDotEnvPath())
			.load();
		if (base.equals("sacoolive" + year[0])) {
			String host = dotenv.get("DB_HOST_WWD");
			String port = dotenv.get("DB_PORT_WWD");
			String databaseName = dotenv.get("DB_NAME_WWD");
			String userSgbd = dotenv.get("DB_USER_WWD");
			String passwordSgbd = dotenv.get("DB_PASS_WWD");
			try {
				String url = "jdbc:jtds:sqlserver://" + host + ":" + port + ";databaseName=" + databaseName + year[0];
				connection = DriverManager.getConnection(url, userSgbd, passwordSgbd);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		} else if (base.equals("BDPersonal")) {
			String host = dotenv.get("DB_HOST_PLA");
			String port = dotenv.get("DB_PORT_PLA");
			String databaseName = dotenv.get("DB_NAME_PLA");
			String userSgbd = dotenv.get("DB_USER_PLA");
			String passwordSgbd = dotenv.get("DB_PASS_PLA");
			try {
				String url = "jdbc:jtds:sqlserver://" + host + ":" + port + ";databaseName=" + databaseName;
				connection = DriverManager.getConnection(url, userSgbd, passwordSgbd);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return connection;
	}

	@Override
	public DocenteDAO getDocenteDAO() {
		return new DocenteSqlServerDAO();
	}

	@Override
	public BaseOpcionDAO getBaseOpcionDAO() {
		return new BaseOpcionSqlServerDAO();
	}

	@Override
	public AsistenciaDAO getAsistenciaDAO() {
		return new AsistenciaSqlServerDAO();
	}

	@Override
	public ReporteAsistProfesoresPorAnioDAO getReporteAsistProfesoresPorAnioDAO() {
		return new SQLReporteAsistProfesoresPorAnioDAO();
	}

	@Override
	public ReporteAsistProfesoresPorMesDAO getReporteAsistProfesoresPorMesDAO() {
		return new SQLReporteAsistProfesoresPorMesDAO();
	}

}
