   /* global loader */

   const helpers = {
   }

   const httpRequest = {
      listarAnios() {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarAniosDB',
               dataType: "json",
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               }, error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      },
      listarMesesActivos(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarMesesActivos',
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               }, error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      }
   }

   const DOMEvents = {
      init() {
         this.depMesToAnio()
         this.changeCboTiempo()
         this.generarReporte()
         this.changeTipoReporte()
      },
      depMesToAnio() {
         $('#cboAnio').change(() => {
            initRequest.cargarMesesActivos()
         })
      },
      changeCboTiempo() {
         $('#cboTiempo').change((e) => {
            let _this = e.currentTarget
            if (_this.value === '1') {
               $('.clAnio').removeClass('col-md-6').addClass('col-md-12')
               $('.clMes').addClass('hide')
            } else {
               $('.clAnio').addClass('col-md-6').removeClass('col-md-12')
               $('.clMes').removeClass('hide')
            }
         })
      },
      changeTipoReporte() {
         $('#tipoReporte').change((e) => {
            let _this = e.currentTarget
            if (_this.value === '1') {
               $('#cboTiempo').html(`<option value="2">Mensual</option><option value="1">Anual</option>`).prop('disabled', false)
            } else {
               $('#cboTiempo').html(`<option value="2">Mensual</option>`).prop('disabled', true)
               $('.clAnio').addClass('col-md-6').removeClass('col-md-12')
               $('.clMes').removeClass('hide')
            }
         })
      },
      generarReporte() {
         $('#btnGenerar').click(() => {
            let año = $('#cboAnio').val()
            let mes = $('#cboMes').val()
            let tipo = $('#tipoReporte').val()
            let rango = $('#cboTiempo').val()
            if (tipo === '1') {
               if (rango === '1') {
                  loader.iniciarLoader()
                  window.location.href = '../vistas/xlsFiles/exportar_asist_profesor_por_anio.jsp?dbanio=' + año
                  loader.terminarLoader()
               } else if (rango === '2') {
                  loader.iniciarLoader()
                  window.location.href = '../vistas/xlsFiles/exportar_asist_profesor_por_mes.jsp?dbanio=' + año + '&mes=' + mes.trim()
                  loader.terminarLoader()
               }
            } else {
               let json = {
                  mesReporte: mes.trim(),
                  dbanio: año
               }
               loader.iniciarLoader()
               window.location.href = '../vistas/xlsFiles/listarDescuentosMensual.jsp?filters=' + JSON.stringify(json)
               loader.terminarLoader()
            }
//            msnError("Antes de generar un reporte, especifique el periodo")
         })
      }
   }

   const initRequest = {
      init() {
         this.cargarAnios()
      },
      cargarAnios() {
         httpRequest.listarAnios()
                 .then((data) => {
                    if (data.status) {
                       let print = ""
                       let lista = data.results
                       for (let i in lista) {
                          let selected
                          if (lista[i].state) {
                             selected = "selected"
                          }
                          print += " <option value ='" + lista[i].anio + "' " + selected + " >" + lista[i].anio + "</option> "
                       }
                       $("#cboAnio").html(print)
                    } else {
                       let print = " <option  value=''>No hay contenido</option> "
                       $("#cboAnio").html(print)
                    }
                 })
                 .then(() => {
                    this.cargarMesesActivos()
                 })
                 .catch(err => console.log(err))
      },
      cargarMesesActivos() {
         let json = {
            year: $('#cboAnio').val()
         }
         httpRequest.listarMesesActivos(json)
                 .then((data) => {
                    if (data.status) {
                       let print = ""
                       let lista = data.results
                       for (let i in lista) {
                          let selected
                          if (lista[i].state) {
                             selected = "selected"
                          }
                          print += " <option value =' " + lista[i].numeroMes + " ' " + selected + " >" + lista[i].nombreMes + "</option> "
                       }
                       $("#cboMes").html(print)
                    } else {
                       let print = " <option  value=''>No hay contenido</option> "
                       $("#cboMes").html(print)
                    }
                 })
                 .catch(err => console.log(err))
      }
   }

   const initComponents = {
   }

   initialize = () => {
      initRequest.init()
      DOMEvents.init()
   }

   initialize() 