   /* global bootbox, Cookies */

   const CONSTANTES = Object.freeze({
      PATH_GENERAL: 'http://localhost:8080/aulaVirtual/',
      PATH_IP: 'http://172.16.2.40:8080/aulaVirtual/',
      CODIGO_PROYECTO_MATRICULA: '25',
      PATH_SERVICIO_REST: 'http://app9.sacooliveros.edu.pe:8080/security-rest/api/'
   })

   let getYearFooter = (footer) => {
      var date = new Date();
      var year = date.getFullYear();
      $(footer).append(year);
   };

   const capitalizeWords = str => str.split(' ').map((word, i, arr) => word.charAt(0).toUpperCase() + word.slice(1).toLowerCase()).join(' ')

   function msnSuccess(message, action, charge) {
      var final = action || function () {};
      let bbxSuccess = bootbox.dialog({
         className: "dialogExtraSmall",
         title: "<i class='ace-icon fa fa-tags white'></i> <span class='white'>Notificación</span>",
         headerClass: "modal-bg-success",
         message: message,
         buttons: {
            si: {
               label: "<i class='fa fa-check bigger-110'></i>&nbsp; Aceptar",
               className: "btn bg-green border-green-600 btn-xs",
               callback: function () {
                  final();
               }
            }
         }
      });
      if (charge !== undefined) {
         bbxSuccess.init(() => {
            charge()
         })
      }
   }

   function msnError(message, action) {
      var final = action || function () {};
      bootbox.dialog({
         className: "dialogExtraSmall",
         title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
         headerClass: "modal-bg-warning",
         message: message,
         buttons: {
            si: {
               label: "<i class='fa fa-check bigger-110'></i>&nbsp; Aceptar",
               className: "btn bg-orange border-orange-600 btn-xs",
               callback: function () {
                  final();
               }
            }
         }
      });
   }

   function msnConfirm(message, action) {
      bootbox.dialog({
         className: "dialogExtraSmall",
         headerClass: "modal-bg-primary",
         title: "<i class='ace-icon fa fa-check-circle white'></i> <span class='white'>Conformidad</span>",
         message: message,
         buttons: {
            si: {
               label: "<i class='fa fa-check bigger-110'></i>&nbsp; Si",
               className: "btn-primary",
               callback: function () {
                  return action(true);
               }
            }, no: {
               label: "<i class='fa fa-times bigger-110'></i>&nbsp; No",
               className: "btn-danger",
               callback: function () {
                  return action(false);
               }
            }
         }
      });
   }

   function deleteAllCookies() {
      var cookies = document.cookie.split(";");
      for (var i = 0; i < cookies.length; i++) {
         var cookie = cookies[i];
         var eqPos = cookie.indexOf("=");
         var name = eqPos > -1 ? cookie.substr(0, eqPos) : cookie;
         document.cookie = name + "=;expires=Thu, 01 Jan 1970 00:00:00 GMT";
      }
   }

   let logOut = () => {
      $('.logOut').click(function () {
         window.location.href = '../vistas/logout';
      })
   }

   var elementLoader = {
      iniciarLoader: function (id) {
         $("#" + id).parent().block({
            message: '<i class="icon-spinner9 spinner position-left"></i>',
            overlayCSS: {
               backgroundColor: '#fff',
               opacity: 0.8,
               cursor: 'wait'
            },
            css: {
               border: 0,
               padding: 0,
               backgroundColor: 'transparent'
            }
         });
      },
      terminarLoader: function (id) {
         $("#" + id).parent().unblock();
      }
   };

   var loader = {
      iniciarLoader: function () {
         $.blockUI({
            message: '<i class="icon-spinner9 spinner position-left" style="font-size:25px"></i>',
            overlayCSS: {
               backgroundColor: '#1b2024',
               opacity: 0.95,
               cursor: 'wait'
            },
            css: {
               border: 0,
               color: '#fff',
               padding: 0,
               backgroundColor: 'transparent'
            }
         });
      },
      terminarLoader: function () {
         $.unblockUI();
      }
   };

   jQuery.expr[':'].regex = function (elem, index, match) {
      var matchParams = match[3].split(','),
              validLabels = /^(data|css):/,
              attr = {
                 method: matchParams[0].match(validLabels) ?
                         matchParams[0].split(':')[0] : 'attr',
                 property: matchParams.shift().replace(validLabels, '')
              },
              regexFlags = 'ig',
              regex = new RegExp(matchParams.join('').replace(/^\s+|\s+$/g, ''), regexFlags);
      return regex.test(jQuery(elem)[attr.method](attr.property));
   }

   const ajaxRemoteSelect2 = obj => {
      $(obj.id).select2({
         language: "es",
         allowClear: obj.allowClear || true,
         ajax: {
            url: obj.url,
            dataType: 'json',
            delay: obj.delay || 250,
            type: obj.type || "POST",
            data: obj.data,
            processResults: function (data, params) {
               params.page = params.page || 1;
               return {
                  results: data.items,
                  pagination: {
                     more: (params.page * 10) < data.total_count
                  }
               };
            },
            cache: true
         },
         width: '100%',
         placeholder: obj.placeholder,
         escapeMarkup: function (markup) {
            return markup;
         },
         minimumInputLength: obj.minimumInputLength,
         templateResult: obj.templateResult,
         templateSelection: obj.templateSelection
      });
   }

   getYearFooter('#footerDate');
