   /* global bootbox, loader */

   let tableAsistencias
   let tableDescuentos
   let listaAsistencia = []
   let listaDescuento = []
   let cantidadAsistencia = '00.00'
   let cantidadDescuento = '00.00'
   let datosDocente = {}
   let listaSueldo = []
   let listaPagos = []
   let busqueda = {}
   let listarRazonesSociales = []
   let finaTable = ''
   let tablaTipoAsistencia = ''
   let totalizadoAsistencias = ''

   const helpers = {
      init() {
         this.chargeCounts()
         this.chargeDatosDocente()
      },
      refreshAsistencias() {
         tableAsistencias.ajax.reload()
      },
      chargeAsistencias() {
         tableAsistencias.destroy()
         initComponents.tblAsistencias()
      },
      refreshDescuentos() {
         tableDescuentos.ajax.reload()
      },
      chargeDescuentos() {
         tableDescuentos.destroy()
         initComponents.tblDescuentos()
      },
      chargeCounts() {
         $('#cantidadAsistencia').text(cantidadAsistencia)
         $('#cantidadDescuento').text(cantidadDescuento)
      },
      chargeDatosDocente() {
         $('#lblCodigo').text(datosDocente.id || ' - ')
         $('#lblApellidos').text(datosDocente.apellidoProfesor || ' - ')
         $('#lblNombres').text(datosDocente.nombreProfesor || ' - ')
         $('#lblPlanilla').text(datosDocente.tipoPlanilla || ' - ')
         $('#lblContrato').text(datosDocente.contratoProfesor || ' - ')
      }
   }

   const httpRequest = {
      listarAnios() {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarAniosDB',
               dataType: "json",
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               }, error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      },
      listarMesesActivos(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarMesesActivos',
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               }, error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      },
      listarRazonSocial(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarRazonSocial',
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               }, error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      },
      listarAsistenciasDescuentos(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarAsistencias',
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               }, error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      },
      listarSueldos(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarSueldos',
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               },
               error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      },
      listarMontosPorPago(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarMontosPorPago',
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               },
               error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      },
      listarResumenRS(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarResumenRS',
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               },
               error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      },
      listarResumenPagos(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarResumenPagos',
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               },
               error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      },
      listarDetalleDescuento() {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../AsistenciaServlet?accion=listarDetalleDescuento',
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               success: function (data, textStatus, jqXHR) {
                  resolve(data)
               },
               error: function (jqXHR, textStatus, errorThrown) {
                  reject('Error en la petición')
               }
            })
         })
      }
   }

   const DOMEvents = {
      init() {
         this.depMesToAnio()
         this.cargarAsistencias()
         this.limpiarCarga()
         this.listarSueldos()
         this.listarPagosPorTipo()
         this.exportarAsistenciaDescuentos()
         this.exportarAsistenciaRS()
         this.mostrarResumenAsistencias()
      },
      depMesToAnio() {
         $('#cboAnio').change(() => {
            initRequest.cargarMesesActivos()
            initRequest.cargarRazonSocial()
         })
      },
      cargarAsistencias() {
         $('#btnBuscar').click(() => {
            finaTable = ''
            let json = {
               year: $('#cboAnio').val(),
               razonSocial: $("#cboRazon").val(),
               codigoDocente: $("#cboDocentes").val(),
               mesAsistencia: $("#cboMes").val().trim()
            }
            if (json.codigoDocente !== null) {
               loader.iniciarLoader()
               busqueda = json
               initRequest.cargarAsistenciasDescuentos(busqueda)
            } else {
               msnError("Especifique un docente para continuar", () => {
                  $('#cboDocentes').select2('open')
                  $("html, body").animate({scrollTop: 0}, "slow");
               })
            }
         })
      },
      limpiarCarga() {
         $('#btnLimpiar').click(() => {
            loader.iniciarLoader()
            document.getElementById("frmBusqRequ").reset();
            $('#cboDocentes').val('').trigger('change');
            tableAsistencias
            tableDescuentos
            listaAsistencia = []
            listaDescuento = []
            cantidadAsistencia = '00.00'
            cantidadDescuento = '00.00'
            datosDocente = {}
            listaSueldo = []
            listaPagos = []
            busqueda = {}
            finaTable = ''
            tablaTipoAsistencia = ''
            totalizadoAsistencias = ''
            S
            helpers.chargeDescuentos()
            helpers.chargeAsistencias()
            helpers.init()
            $('#btnSueldos').attr('disabled', true)
            $('#btnPagos').attr('disabled', true)
            loader.terminarLoader()
         })
      },
      listarSueldos() {
         $('#btnSueldos').click(() => {
            if (busqueda.hasOwnProperty("codigoDocente") && busqueda.hasOwnProperty("mesAsistencia")) {
               let listaSueldos = bootbox.dialog({
                  title: "<i class='ace-icon fa fa-tags'></i> <span class=''>&nbsp; LISTADO DE SUELDOS</span>",
                  headerClass: `modal-bg-primary`,
                  className: 'dialogExtraSmall',
                  message: `<div class="table-responsive">
                                    <table class="table display dataTable table-striped table-hover table-sm table-bordered" id="tblSueldos">                                                 
                                        <thead class="">
                                            <tr>
                                                <th class="text-center">PAGO</th>
                                                <th class="text-center">MONTO</th>                                       
                                            </tr>
                                        </thead>
                                    </table>
                               </div>`
               })
               listaSueldos.init(() => {
                  $('.modal-body').addClass('modal-bodys')
                  $('.modal-bodys').removeClass('modal-body')
                  $('.bootbox-close-button').removeClass('hide')
                  initComponents.tblPagos()
               })
            } else {
               msnError("Antes de generar un reporte, especifique un Docente", () => {
                  $('#cboDocentes').select2('open')
                  $("html, body").animate({scrollTop: 0}, "slow");
               })
            }
         })
      },
      listarPagosPorTipo() {
         $('#btnPagos').click(() => {
            if (busqueda.hasOwnProperty("codigoDocente") && busqueda.hasOwnProperty("mesAsistencia")) {
               let listaPagos = bootbox.dialog({
                  title: "<i class='ace-icon fa fa-tags'></i> <span class=''>&nbsp; PAGOS POR TIPO</span>",
                  headerClass: `modal-bg-primary`,
                  size: 'medium',
                  message: `<div class="table-responsive">
                                    <table class="table display dataTable table-striped table-hover table-sm table-bordered" id="tblPagos">                                                 
                                        <thead class="">
                                            <tr>
                                                <th class="text-center">Nº</th>
                                                <th class="text-center">SECCION</th>                                       
                                                <th class="text-center">MINUTOS</th>                                       
                                                <th class="text-center">HORAS</th>                                       
                                                <th class="text-center">MONTO</th>                                       
                                                <th class="text-center">ACUMULADO</th>                                       
                                            </tr>
                                        </thead>
                                    </table>
                                    <div class="col-md-12 text-right"> 
                                       <label class="footer-text"><b>Monto Total Asistencias:</b></label>
                                       <label class="footer-text">&nbsp;<span id="montoTotal"></span></label>
                                     </div>
                               </div>`
               })
               listaPagos.init(() => {
                  $('.modal-body').addClass('modal-bodys')
                  $('.modal-bodys').removeClass('modal-body')
                  $('.bootbox-close-button').removeClass('hide')
                  initComponents.tblAcumulado()
                  $('#montoTotal').text(cantidadAsistencia)
               })
            } else {
               msnError("Antes de generar un reporte, especifique un Docente", () => {
                  $('#cboDocentes').select2('open')
                  $("html, body").animate({scrollTop: 0}, "slow");
               })
            }
         })
      },
      exportarAsistenciaDescuentos() {
         $('#btnAsistenciaDescuento').click(() => {
            if (busqueda.hasOwnProperty("codigoDocente") && busqueda.hasOwnProperty("mesAsistencia")) {
               loader.iniciarLoader()
               window.location.href = '../vistas/xlsFiles/reporteAsistenciaDescuento.jsp?filters=' + JSON.stringify(busqueda) + '&docente=' + JSON.stringify(datosDocente)
               loader.terminarLoader()
            } else {
               msnError("Antes de generar un reporte, especifique un Docente", () => {
                  $('#cboDocentes').select2('open')
                  $("html, body").animate({scrollTop: 0}, "slow");
               })
            }
         })
      },
      exportarAsistenciaRS() {
         $('#btnAsistenciaRS').click(() => {
            if (busqueda.hasOwnProperty("codigoDocente") && busqueda.hasOwnProperty("mesAsistencia")) {
               loader.iniciarLoader()
               window.location.href = '../vistas/xlsFiles/reporteAsistenciasPorRS.jsp?filters=' + JSON.stringify(busqueda) + '&docente=' + JSON.stringify(datosDocente)
               loader.terminarLoader()
            } else {
               msnError("Antes de generar un reporte, especifique un Docente", () => {
                  $('#cboDocentes').select2('open')
                  $("html, body").animate({scrollTop: 0}, "slow");
               })
            }
         })
      },
      mostrarResumenAsistencias() {
         $('#btnResumenAsistencia').click(() => {
            if (busqueda.hasOwnProperty("codigoDocente") && busqueda.hasOwnProperty("mesAsistencia")) {
               let resumenAsistencia = bootbox.dialog({
                  title: "<i class='ace-icon fa fa-tags'></i> <span class=''>&nbsp; RESUMEN DE ASISTENCIAS</span>",
                  headerClass: `modal-bg-primary`,
                  className: "modal-xmd",
                  message: `<form class="padding">
                                    <div class="row">
                                       <div class="table-responsive">
                                          <h4 class="text-muted">
                                                 <em class="fa fa-clock-o"></em>
                                                 TOTAL DE HORAS TRABAJADAS:
                                          </h4>
                                          <h7 class="text-dark text-bold">
                                                ${totalizadoAsistencias.totalHoras.split(':')[0]} HORAS Y ${totalizadoAsistencias.totalHoras.split(':')[1]} MINUTOS
                                          </h7>
                                          <h4 class="text-muted">
                                                 <em class="fa fa-clock-o"></em>
                                                  HORAS Y MONTOS POR TIPO DE ASISTENCIA:
                                          </h4>
                                          ${tablaTipoAsistencia}
                                          <h4 class="text-muted">
                                                 <em class="fa fa-clock-o"></em>
                                                  HORAS Y MONTOS POR RAZON SOCIAL Y LOCAL:
                                          </h4>
                                          ${finaTable}
                                       </div>
                                     </div>
                               </form>`
               })
               resumenAsistencia.init(() => {
                  $('.bootbox-close-button').removeClass('hide')
                  $('.modal-body').removeClass('modal-body')
               })
            } else {
               msnError("Antes de generar un reporte, especifique un Docente", () => {
                  $('#cboDocentes').select2('open')
                  $("html, body").animate({scrollTop: 0}, "slow");
               })
            }
         })
      },
      mostrarDetalleDescuento() {
         $('#tblDescuentos tbody').off('click', '.detalleDescuento')
         $('#tblDescuentos tbody').on('click', '.detalleDescuento', (e) => {

         })
      }
   }

   const initRequest = {
      init()
      {
         this.cargarAnios()
      },
      cargarAnios() {
         httpRequest.listarAnios()
                 .then((data) => {
                    if (data.status) {
                       let print = ""
                       let lista = data.results
                       for (let i in lista) {
                          let selected
                          if (lista[i].state) {
                             selected = "selected"
                          }
                          print += " <option value ='" + lista[i].anio + "' " + selected + " >" + lista[i].anio + "</option> "
                       }
                       $("#cboAnio").html(print)
                    } else {
                       let print = " <option  value=''>No hay contenido</option> "
                       $("#cboAnio").html(print)
                    }
                 })
                 .then(() => {
                    this.cargarMesesActivos()
                    this.cargarRazonSocial()
                 })
                 .catch(err => console.log(err))
      },
      cargarMesesActivos() {
         let json = {
            year: $('#cboAnio').val()
         }
         httpRequest.listarMesesActivos(json)
                 .then((data) => {
                    if (data.status) {
                       let print = ""
                       let lista = data.results
                       for (let i in lista) {
                          let selected
                          if (lista[i].state) {
                             selected = "selected"
                          }
                          print += " <option value =' " + lista[i].numeroMes + " ' " + selected + " >" + lista[i].nombreMes + "</option> "
                       }
                       $("#cboMes").html(print)
                    } else {
                       let print = " <option  value=''>No hay contenido</option> "
                       $("#cboMes").html(print)
                    }
                 })
                 .catch(err => console.log(err))
      },
      cargarRazonSocial() {
         let json = {
            year: $('#cboAnio').val()
         }
         httpRequest.listarRazonSocial(json)
                 .then((data) => {
                    if (data.status) {
                       let lista = data.results
                       listarRazonesSociales = lista
                       let print = lista.length > 1 ? "<option value='0' selected>Todos</option>" : ''
                       for (let i in lista) {
                          print += " <option value ='" + lista[i].idRazon + "'>" + lista[i].nomRazon + "</option> "
                       }
                       $("#cboRazon").html(print)
                       $("#cboRazon").attr('disabled', lista.length > 1 ? false : true)
                    } else {
                       let print = " <option  value=''>No hay contenido</option> "
                       $("#cboRazon").html(print)
                    }
                 })
                 .catch(err => console.log(err))
      },
      cargarAsistenciasDescuentos(json) {
         httpRequest.listarAsistenciasDescuentos(json)
                 .then(data => {
                    listaAsistencia = data.listaAsis
                    listaDescuento = data.listaDesc
                    cantidadAsistencia = data.contaAsis || '00.00'
                    cantidadDescuento = data.contaDesc || '00.00'
                    return {
                       a: listaAsistencia.length,
                       b: listaDescuento.length
                    }
                 })
                 .then((c) => {
                    if (c.a < 1 && c.b < 1) {
                       msnError("El docente seleccionado no tiene datos en el periodo indicado", () => {
                          $("html, body").animate({scrollTop: 0}, "slow")
                       })
                    } else {
                       initRequest.cargarSueldos()
                       initRequest.cargarPago()
                       initRequest.cargarResumenRS()
                    }
                    helpers.chargeDescuentos()
                    helpers.chargeAsistencias()
                    helpers.init()
                 })
                 .then(() => {
                    loader.terminarLoader()
                 })
      },
      cargarSueldos() {
         if (datosDocente.hasOwnProperty("id") && datosDocente.id !== "") {
            httpRequest.listarSueldos({
               codigoDocente: datosDocente.id,
               year: $('#cboAnio').val()
            })
                    .then(data => {
                       listaSueldo = data.results
                    })
                    .then(() => {
                       $('#btnSueldos').attr('disabled', false)
                    })
                    .catch(err => console.log(err))
         } else {
            $('#btnSueldos').attr('disabled', true)
         }
      },
      cargarPago() {
         if (datosDocente.hasOwnProperty("id") && datosDocente.id !== "" && busqueda.hasOwnProperty("mesAsistencia")) {
            httpRequest.listarMontosPorPago({
               codigoDocente: datosDocente.id,
               year: $('#cboAnio').val(),
               mesAsistencia: busqueda.mesAsistencia
            })
                    .then(data => {
                       listaPagos = data.results
                    })
                    .then(() => {
                       $('#btnPagos').attr('disabled', false)
                    })
                    .catch(err => console.log(err))
         } else {
            $('#btnPagos').attr('disabled', true)
         }
      },
      cargarResumenRS() {
         tablaTipoAsistencia = ''
         finaTable = ''
         $('#btnResumenAsistencia').attr("disabled", true)
         $('#btnResumenAsistencia').html("<img src='../img/loading_data.gif'/>&nbsp; Cargando resultados...")
         for (let j in listarRazonesSociales) {
            httpRequest.listarResumenRS({
               codigoDocente: busqueda.codigoDocente,
               mesAsistencia: busqueda.mesAsistencia,
               razonSocial: listarRazonesSociales[j].idRazon
            })
                    .then(data => {
                       let tabla = ''
                       let tbody = ''
                       let lista = data.results
                       for (let i in lista) {
                          let styles = ""
                          switch (lista[i].tipoRegistro) {
                             case 3:
                                styles = "bodyNeto"
                                break;
                             case 2:
                                if (lista[i].totalHoras.trim() === '---' && lista[i].montoTotal.trim() === '---') {
                                   styles = "bodyTotalesDis"
                                } else {
                                   styles = "bodyTotales"
                                }
                                break;
                             default :
                                styles = "bodySede"
                          }
                          tbody += ` <tr class="${styles}">
                                                <td class=" text-center">${lista[i].nombreConcepto}</td>
                                                <td class=" text-center">${lista[i].totalHoras}</td>
                                                <td class=" text-center">${lista[i].montoTotal}</td>
                                          </tr>`
                       }
                       tabla = `<h7 class="text-dark text-bold">${listarRazonesSociales[j].nomComRazon} (${listarRazonesSociales[j].nomRazon}) </h7>
                                                <table class="table wtb display table-striped table-hover">                                                 
                                                    <thead>
                                                       <tr class="headerBlue">
                                                         <th class="text-center">LOCAL</th>
                                                         <th class="text-center">HRS Y MINS</th>                                       
                                                         <th class="text-center">MONTO</th>                                       
                                                      </tr>
                                                   </thead>
                                                   <tbody>
                                                            ${tbody}
                                                   </tbody>
                                                </table> <br>`
                       finaTable += tabla
                    })
                    .then(() => {
                       debugger;
                       if (Number(listarRazonesSociales.length - 1) === Number(j)) {
                          $('#btnResumenAsistencia').html(`<i class="fa fa-file-text"></i>&nbsp; RESUMEN DE ASISTENCIAS`)
                          $('#btnResumenAsistencia').attr("disabled", false)
                       }
                    })
                    .catch((e) => {
                       $('#btnResumenAsistencia').html(`<i class="fa fa-file-text"></i>&nbsp; RESUMEN DE ASISTENCIAS`)
                       $('#btnResumenAsistencia').attr("disabled", false)
                       console.log(`Error ${e}`)
                    })
         }
         httpRequest.listarResumenPagos({
            codigoDocente: busqueda.codigoDocente,
            mesAsistencia: busqueda.mesAsistencia
         })
                 .then(data => {
                    let tabla = ''
                    let tbody = ''
                    let lista = data.results
                    for (let i in lista) {
                       tbody += ` <tr class="bodySede">
                                                <td class=" text-center">${lista[i].tipoAsistencia}</td>
                                                <td class=" text-center">${lista[i].totalHoras}</td>
                                                <td class=" text-center">${lista[i].montoTotal}</td>
                                          </tr>`
                    }
                    let datos = data.data
                    totalizadoAsistencias = datos
                    tbody += ` <tr class ="bodyTotales">
                                                <td class=" text-center">TOTAL :</td>
                                                <td class=" text-center">${datos.totalHoras}</td>
                                                <td class=" text-center">${datos.montoTotal}</td>
                                          </tr>`
                    tabla = `<table class="table wtb display table-striped table-hover">                                                 
                                                    <thead>
                                                       <tr class="headerBlue">
                                                         <th class="text-center">LOCAL</th>
                                                         <th class="text-center">HRS Y MINS</th>                                       
                                                         <th class="text-center">MONTO</th>                                       
                                                      </tr>
                                                   </thead>
                                                   <tbody>
                                                            ${tbody}
                                                   </tbody>
                                                </table> <br>`
                    return tabla
                 })
                 .then(tabla => {
                    tablaTipoAsistencia = tabla
//                    $('#btnResumenAsistencia').html(`<i class="fa fa-file-text"></i>&nbsp; RESUMEN DE ASISTENCIAS`)
//                    $('#btnResumenAsistencia').attr("disabled", false)
                 })
                 .catch((e) => {
//                    $('#btnResumenAsistencia').html(`<i class="fa fa-file-text"></i>&nbsp; RESUMEN DE ASISTENCIAS`)
//                    $('#btnResumenAsistencia').attr("disabled", false)
                    console.log(`Error ${e}`)
                 })
      }
   }

   const initComponents = {
      init() {
         this.select2Docentes()
         this.tblAsistencias()
         this.tblDescuentos()
      },
      select2Docentes() {
         ajaxRemoteSelect2({
            id: "#cboDocentes",
            url: '../AsistenciaServlet?accion=listarDocentesSelect2',
            data: params => {
               return {
                  search: params.term,
                  page: params.page || 1,
                  year: $('#cboAnio').val()
               };
            },
            placeholder: 'Buscar por nombre o dni',
            minimumInputLength: 1,
            templateResult: repo => {
               if (repo.loading) {
                  return repo.text;
               }
               var markup =
                       ` <div class="row"> 
                                 <div class="col-md-5 col-sm-5"> ${repo.apellidoProfesor + ', ' + repo.nombreProfesor} </div>
                                 <div class="col-md-2 col-sm-2 text-center"> ${repo.dniProfesor} </div>
                                 <div class="col-md-2 col-sm-2 text-center"> ${repo.tipoSueldo} </div>
                                 <div class="col-md-3 col-sm-3 text-center"> ${repo.tipoPlanilla} </div>
                          </div>`
               return markup;
            },
            templateSelection: repo => {
               let text = 'Buscar por nombre o dni';
               if (repo.id) {
                  text = repo.apellidoProfesor + ', ' + repo.nombreProfesor;
               }
               datosDocente = repo
               return text;
            }
         });
      },
      tblAsistencias() {
         tableAsistencias = $("#tblAsistencias").DataTable({
            "language": {
               "lengthMenu": "Mostrar: _MENU_",
               "zeroRecords": "&nbsp;&nbsp;&nbsp; No se encontraron resultados",
               "info": "&nbsp;&nbsp;&nbsp; Mostrando del _START_ al _END_ de un total de _TOTAL_ registros",
               "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
               "search": "Filtrar:",
               "loadingRecords": "Cargando...",
               "processing": 'Procesando...',
               "paginate": {
                  "first": "First",
                  "last": "Last",
                  "next": "Siguiente",
                  "previous": "Anterior"
               }
            },
            dom: '<"datatable-scroll"t>r<"datatable-footers">',
            data: listaAsistencia,
            "bSort": false,
            "bFilter": false,
            "serverSide": false,
            "processing": true,
            "aaSorting": [],
            "ordering": false,
            "bLengthChange": false,
            "bInfo": false,
            "paging": false,
            "iDisplayLength": -1,
            "columnDefs": [
               {targets: 0, orderable: false, width: "2%", className: "text-center"},
               {targets: 1, orderable: false, width: "2%", className: "text-center"},
               {targets: 2, orderable: false, width: "2%", className: "text-center"},
               {targets: 3, orderable: false, width: "2%", className: "text-center"},
               {targets: 4, orderable: false, width: "2%", className: "text-center"},
               {targets: 5, orderable: false, width: "3%", className: "text-center"},
               {targets: 6, orderable: false, width: "7%", className: "text-center"},
               {targets: 7, orderable: false, width: "2%", className: "text-center"},
               {targets: 8, orderable: false, width: "2%", className: "text-center"},
               {targets: 9, orderable: false, width: "2%", className: "text-center"},
               {targets: 10, orderable: false, width: "2%", className: "text-center"},
               {targets: 11, orderable: false, width: "7%", className: "text-center"},
               {targets: 12, orderable: false, width: "10%", className: "text-center"},
               {targets: 13, orderable: false, width: "3%", className: "text-center"},
               {targets: 14, orderable: false, width: "3%", className: "text-center"},
               {targets: 15, orderable: false, width: "10%", className: "text-center"}
            ],
            "columns": [
               {"data": "numeral"},
               {"data": "codigoAsistencia"},
               {"data": "horaIngreso"},
               {"data": "horaSalida"},
               {"data": "horaIngresoT"},
               {"data": "horaSalidaT"},
               {"data": null, "render": (data, type, row) => {
                     return `${row.diaAsistencias} - ${row.fechaAsistencias}`
                  }
               },
               {"data": "seccion"},
               {"data": "costoSeccion"},
               {"data": "horasLaboro"},
               {"data": "montoLaboro"},
               {"data": "sede"},
               {"data": "aulas"},
               {"data": "tipo/dia"},
               {"data": "estadoAsistencia", "render": (data, type, row) => {
                     if (data.trim() !== '-') {
                        switch (data.trim()) {
                           case 'ASISTIO':
                              return '<span class="label label-success">ASISTIÓ</span>'
                              break;
                           case 'TARDANZA':
                              return '<span class="label bg-orange">TARDANZA</span>'
                              break;
                           case 'FSA':
                              return '<span class="label label-danger">FALTA</span>'
                              break;
                           case 'REMPLAZO':
                              return '<span class="label label-info">REEMPLAZO</span>'
                              break;
                           default:
                              return '<span class="label label-slate">' + data.trim() + '</span>'
                        }
                     } else {
                        return data
                     }
                  }
               },
               {"data": "observacion", render: (data, type, row) => {
                     if (data.length <= 0) {
                        return ' - '
                     } else {
                        return data
                     }
                  }
               }
            ]
         });
      },
      tblDescuentos() {
         tableDescuentos = $("#tblDescuentos").DataTable({
            "language": {
               "lengthMenu": "Mostrar: _MENU_",
               "zeroRecords": "&nbsp;&nbsp;&nbsp; No se encontraron resultados",
               "info": "&nbsp;&nbsp;&nbsp; Mostrando del _START_ al _END_ de un total de _TOTAL_ registros",
               "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
               "search": "Filtrar:",
               "loadingRecords": "Cargando...",
               "processing": 'Procesando...',
               "paginate": {
                  "first": "First",
                  "last": "Last",
                  "next": "Siguiente",
                  "previous": "Anterior"
               }
            },
            dom: '<"datatable-scroll"t>r<"datatable-footers">',
            data: listaDescuento,
            "bSort": false,
            "bFilter": false,
            "serverSide": false,
            "processing": true,
            "aaSorting": [],
            "ordering": false,
            "bLengthChange": false,
            "bInfo": false,
            "paging": false,
            "iDisplayLength": -1,
            "columnDefs": [
               {targets: 0, orderable: false, width: "1%", className: "text-center"},
               {targets: 1, orderable: false, width: "2%", className: "text-center"},
               {targets: 2, orderable: false, width: "2%", className: "text-center"},
               {targets: 3, orderable: false, width: "2%", className: "text-center"},
               {targets: 4, orderable: false, width: "2%", className: "text-center"},
               {targets: 5, orderable: false, width: "3%", className: "text-center"},
               {targets: 6, orderable: false, width: "3%", className: "text-center"},
               {targets: 7, orderable: false, width: "2%", className: "text-center"},
               {targets: 8, orderable: false, width: "2%", className: "text-center"},
               {targets: 9, orderable: false, width: "2%", className: "text-center"},
               {targets: 10, orderable: false, width: "2%", className: "text-center"},
               {targets: 11, orderable: false, width: "5%", className: "text-center"}
//               {targets: 12, orderable: false, width: "1%", className: "text-center"}
            ],
            "columns": [
               {"data": "numeral"},
               {"data": "codigoDescuento"},
               {"data": "codigoAsistencia"},
               {"data": "horaIngreso"},
               {"data": "horaSalida"},
               {"data": "horaIngresoT"},
               {"data": "fechaAsistencias"},
               {"data": "montoDescuento"},
               {"data": "sede"},
               {"data": "seccion"},
               {"data": "motivo"},
               {"data": "observacion", render: (data, type, row) => {
                     if (data.length <= 0) {
                        return ' - '
                     } else {
                        return data
                     }
                  }
               }
//               {"data": null, render: (data, type, row) => {
//                     return '<a class="detalleDescuento"><i class="icon-eye"></i></a>'
//                  }
//               }
            ],
            fnDrawCallback: () => {
               DOMEvents.mostrarDetalleDescuento()
            }
         });
      },
      tblPagos() {
         tablePagos = $("#tblSueldos").DataTable({
            "language": {
               "lengthMenu": "Mostrar: _MENU_",
               "zeroRecords": "&nbsp;&nbsp;&nbsp; No se encontraron resultados",
               "info": "&nbsp;&nbsp;&nbsp; Mostrando del _START_ al _END_ de un total de _TOTAL_ registros",
               "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
               "search": "Filtrar:",
               "loadingRecords": "Cargando...",
               "processing": 'Procesando...',
               "paginate": {
                  "first": "First",
                  "last": "Last",
                  "next": "Siguiente",
                  "previous": "Anterior"
               }
            },
            dom: '<"datatable-scroll"t>r<"datatable-footers">',
            data: listaSueldo,
            "bSort": false,
            "bFilter": false,
            "serverSide": false,
            "processing": true,
            "aaSorting": [],
            "ordering": false,
            "bLengthChange": false,
            "bInfo": false,
            "paging": false,
            "iDisplayLength": -1,
            "columnDefs": [
               {targets: 0, orderable: false, width: "50%", className: "text-center"},
               {targets: 1, orderable: false, width: "50%", className: "text-center"}
            ],
            "columns": [
               {"data": "nombrePago"},
               {"data": "montoPago"}
            ]
         });
      },
      tblAcumulado() {
         tableAcumulado = $("#tblPagos").DataTable({
            "language": {
               "lengthMenu": "Mostrar: _MENU_",
               "zeroRecords": "&nbsp;&nbsp;&nbsp; No se encontraron resultados",
               "info": "&nbsp;&nbsp;&nbsp; Mostrando del _START_ al _END_ de un total de _TOTAL_ registros",
               "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
               "search": "Filtrar:",
               "loadingRecords": "Cargando...",
               "processing": 'Procesando...',
               "paginate": {
                  "first": "First",
                  "last": "Last",
                  "next": "Siguiente",
                  "previous": "Anterior"
               }
            },
            dom: '<"datatable-scroll"t>r<"datatable-footers">',
            data: listaPagos,
            "bSort": false,
            "bFilter": false,
            "serverSide": false,
            "processing": true,
            "aaSorting": [],
            "ordering": false,
            "bLengthChange": false,
            "bInfo": false,
            "paging": false,
            "iDisplayLength": -1,
            "columnDefs": [
               {targets: 0, orderable: false, width: "5%", className: "text-center"},
               {targets: 1, orderable: false, width: "5%", className: "text-center"},
               {targets: 2, orderable: false, width: "7%", className: "text-center"},
               {targets: 3, orderable: false, width: "7%", className: "text-center"},
               {targets: 4, orderable: false, width: "10%", className: "text-center"},
               {targets: 5, orderable: false, width: "10%", className: "text-center"}
            ],
            "columns": [
               {"data": "numeral"},
               {"data": "seccion"},
               {"data": "minutos"},
               {"data": "horas"},
               {"data": "monto"},
               {"data": "subtotal"}
            ]
         });
      }
   }

   initialize = () => {
      initRequest.init()
      DOMEvents.init()
      initComponents.init()
      helpers.init()
   }

   initialize() 